diff --git a/src/bin/psql/startup.c b/src/bin/psql/startup.c
index 249b6aa516..043972a37e 100644
--- a/src/bin/psql/startup.c
+++ b/src/bin/psql/startup.c
@@ -278,6 +278,9 @@ main(int argc, char *argv[])
 		free(keywords);
 		free(values);
 
+		if (!pset.db)
+			pg_fatal("could not connect to server");
+
 		if (PQstatus(pset.db) == CONNECTION_BAD &&
 			PQconnectionNeedsPassword(pset.db) &&
 			!password &&
